function dy = CSTR_sedo(t,y)

% non-isothermal CSTR

global R U ro Cp Hr Ea ko D Cv A Tw x F Tf Caf

h = y(1);
Ca = y(2);
T = y(3);

dy = [(F - x * Cv * sqrt(h))/A;
      F * (Caf - Ca) / (A * h) - ko * exp(-Ea/(R*T)) * Ca;
      F * (Tf - T) / (A * h) + (-Hr) * ko * exp(-Ea/(R*T)) * Ca / (ro * Cp) - U * (1 + 4 * h / D) * (T - Tw) / (h * ro * Cp)];
